#include <stdio.h>
#include <malloc.h>
#include "xalloc.h"

AllocNum xalloc_num = 0;
AllocSize xalloc_size = 0;
AllocMagic magicalloc = 0x5675345;
#define Bool int
#define YES 1
#define NO 0

void mem_error()
{
/* useful breakpoint */
}

void *chk_malloc(AllocSize size)
    {
#ifndef NDEBUG
	void * rtn;
	xalloc_num++;
	xalloc_size += size;
	rtn = malloc(size + sizeof(AllocSize) + sizeof(AllocMagic)*2);
	if (rtn == NULL)
		{
		fprintf(stderr, "memory allocation error\n");
		mem_error();
		abort();
		}
	*((AllocMagic *)rtn) = magicalloc;
	((AllocMagic *)rtn)++;
	*((AllocSize *)rtn) = size;
	((AllocSize *)rtn)++;
	*((AllocMagic *)(((char *)rtn)+size)) = magicalloc;
	errfmt("malloc:%d\n", rtn);
	return rtn; 
#else
	return malloc(size);
#endif
	}

void chk_free(void * block)
	{
#ifndef NDEBUG
	AllocMagic * end;
	Bool ok = YES;
#endif
	if (block == NULL)
		return;
#ifndef NDEBUG
	errfmt("chk_free:%d\n", block);
	xalloc_num--;
	((AllocSize *)block)--;
	end = ((AllocMagic *)(((char *)block)+sizeof(AllocSize) + *((AllocSize *)block)));              
	if (*end != magicalloc)
		{
		fprintf(stderr, "memory free error (end)");
		mem_error();
		ok = NO;
		}
	if (ok)
		*end = 0;
	xalloc_size -= *((AllocSize *)block);
	((AllocMagic *)block)--;
	if (*((AllocMagic *)block) != magicalloc)
		{
		fprintf(stderr, "memory free error (beginning)");
		mem_error();
		ok = NO;
		}
	if (ok) 
		*((AllocMagic *)block) = 0;
	if (!ok)
		abort();
	if (ok)
#endif
		free(block);
	}

#define   mini(a,b)        ((a) < (b) ? (a) : (b))
	
void * chk_realloc(void * block, AllocSize size)
	{   
#ifndef NDEBUG
	void * rtn;
	AllocSize oldsize, minim;
	if (block == NULL)
		return chk_malloc(size);
	oldsize = *(((AllocSize *)block) - 1);
	minim = mini(size, oldsize);
	rtn = chk_malloc(size);
	memmove(rtn, block, minim);
	chk_free(block);
	errfmt("realloc:%d-%d\n", block, rtn);
	return rtn;
#else
	if (block == NULL)
		return malloc(size);
	return realloc(block, size);
#endif
	}

char * chk_strdup(char const * str)
	{
	char * rtn = chk_malloc(strlen(str) + 1);
	strcpy(rtn, str);
	return rtn;
	}
	
	
	
