.\" @(#)$$
.\"
.\" Comments
.\"
.TH BIBLETECH 1 "May 4, 1995"
.SH NAME
cbible, xmbible \- Bible viewers
.SH SYNOPSIS
.B cbible
.RB [ \-v
.IR version ]
.RB [ \-s
.IR search-expression ]
.RB [ \-r
.IR range ]
.RI [ none ]
.B xmbible
.SH DESCRIPTION
Bible is a bible study tool designed to allow viewing, searching,
and other activities useful for bible study.
The command line oriented version of the program is called
.I cbible.\^
The X windows Motif version is called
.I xmbible.\^
The software currently comes with the Authorized (King James) version,
although other versions are easily used, as well as non-bible religious
books.
Bible also supports bookmarks which are predefined verse ranges. Verse
ranges need not be contiguous.
The program accesses the source text, as a separate file for each book.
Books may be compressed with gzip and will be automatically
decompressed when accessed.
.RE
.SS Verse References and Ranges
Bible accepts verse references and verse ranges in a variety of forms.
For example:

  Jn 3:16
  Jn 3:16,17
  Jn 3:16-20
  Jn 3:1-3:16
  Mt 2:1-Jn 3:16
  Mt-Rev
  Ge-Dt,Mt-Jn,Ro1:1-9:33

The full names of the books may be used if they have been mapped
to the abbreviations in your bookmark file. The standard bookmark file
does this.
No distinction is made between upper and lower case.
.PP
Verse and chapter will be silently coerced into a realistic range, e.g.
"Ge1:50" will be treated as Genesis 1:31 since there are only thirty-one 
verses in Genesis 1, and 
"Rev99:99" will be treated as Revelation 22:21.
A book name by itself is assumed to be a reference to the entire book.
Similarly, a book and chapter without a verse is assumed to refer the 
entire chapter.
.PP
A range of verses may be printed by giving a starting and ending reference, 
separated by a hyphen ("-").
For example, "Gen1:1-Rev22:21" refers to the entire text of the bible.
.PP
Non-contiguous ranges may be specified by separating the components by a 
comma or space. For example, "Mt,Mk,Lk,Ac 1:1-14" 


.SS The Command Line Interface
.I cbible\^
is the command line interface for
.I Bibletech.\^
.PP
.SS Options
The options to
.I cbible\^
are:
.TP 15 "\w'\-t\ prefix\ \ 'u"
.B \-v \ version
Sets the version of the bible to use, or the text name if not using the bible.
.TP
.BI \-s \ search-expression
The expression to search for in the bible.
.TP
.BI \-r \ range
The range of the bible to consider. Ranges need not be contiguous.
.SS Interactive Use
For interactive use, invoke
.I cbible\^
without any verse references on the command line.  You should see a prompt
displayed:

[.] 

Typing
.TP
.B ?
will print a command summary.
.TP
.B loadv
.I version
will load a particular version or text, changing your prompt to:

[ver.]

.TP
.B loadb
.I bookname
will load a particular book of the bible or text, changing your prompt to:

[ver.bookname]

.I Cbible\^
keeps track of your current context and will attempt to 
interpret references in that context.
For example if you request "Jn1:1", followed by "3:16", and then "17", 
the second reference is assumed to be within the book of John, and the third
is assumed to be within chapter 3 of that book.

.SS Searching
To make complex searches from
.I cbible\^
use the
.BI search
command.

.I Cbible\^
will display the number of matching references, if any, but since the
number could be quite large, it won't actually list the references
until you ask.
.PP
In order to list the references from a word search, the
.B list
(or
.BR l )
command is used.  Likewise, to print the full text of the verses
selected by a word search, use the
.B view
(or
.BR v )
command.
.PP
be dropped.  Note that only a contiguous range of verses may be used.

.SS The Motif Interface
.PP
.I xmbible\^
is the Motif interface for
.I Bibletech.\^
.SS Searching
To make complex searches from
.I xmbible\^
select
.BI Search
from the 
.BI Edit
menu.

.RE
.PD
.SH COPYING
This release of Bibletech is freely distributable under the terms of the
GNU Public Licence (GPL).
The copyright is owned by Chris Bitmead.
.SH BUGS 
References to the one-chapter books such as Obadiah
are non-standard in that they require a dummy chapter number.  For
example, use Ob1:10 instead of Ob10 to search for verse 10.
.PP
The current algorithm for searchingis not terribly efficient.
.SH NOTES
Any queries regarding the text itself should be sent to yhwh@heaven.gov
routed via gateway prayer.edu.
.SH FILES
/usr/local/lib/bible
.SH SEE ALSO
Ro 4:3
.SH AUTHOR
Chris Bitmead, Tech Pty Ltd (chrisb@ind.tansu.com.au).
(Get the latest version of bibletech to get the most up-to-date email address)
